package CompileZ;

import org.jdom.*; 
import org.jdom.output.*;

import java.io.*;


public class XMLCreation {

	ParsingZ pZ;
	String StSchema;
	XMLCreation(String Name){
		pZ = new ParsingZ(Name);
		StSchema=pZ.getStyleSchemaName();
		pZ.Zsp.StyleSchema(StSchema);
		pZ.getOperationName(StSchema);
	}
	
	static File f = new File("Zspecification.xml");
	
	public void createXML(){
		
		try{
		 Element racine = new Element("Zspecification");
		 Attribute StyleSchema = new Attribute("Name",StSchema);
		 racine.setAttribute(StyleSchema);
		 Document doc = new Document(racine);
		 for(int i=0; i<pZ.Zsp.nbC;i++){
			 String component=pZ.Zsp.TabComp[i][2];
			 Element comp = new Element("Components");
	  		 racine.addContent(comp);
	  		 Attribute NameC = new Attribute("Name",component);
	  		 comp.setAttribute(NameC);
	  		 
	  		 if(pZ.isSchema(component)){
	  			Element Zp = new Element("Zpresentation");
	  			comp.addContent(Zp);
		  		Attribute  nameZp= new Attribute("Type","Zschema");
		  		Zp.setAttribute(nameZp);
	  			 
	  		 }
	  			 
	  		 
	  		Element Occur = new Element("Occurrence");
	  		String typeOcc="";
	  		if(pZ.Zsp.TabComp[i][1].equals("\\finset"))
	  			typeOcc="FiniteSet";
	  		if(pZ.Zsp.TabComp[i][1].equals("\\seq"))
	  			typeOcc="Sequence";
	  		Attribute TypeOccu = new Attribute("Type",typeOcc);
	  		Occur.setAttribute(TypeOccu);
	  		comp.addContent(Occur);
	  		
	  		
	  		
	  		for(int j=0; j<pZ.Zsp.nbR;j++){
	  			String RelName=pZ.Zsp.TabRelat[j][0];
		  		if((component.equals(pZ.Zsp.TabRelat[j][1]))||(component.equals(pZ.Zsp.TabRelat[j][2]))){
		  			String otherComp="";
		  			if (component.equals(pZ.Zsp.TabRelat[j][1]))
		  				otherComp=pZ.Zsp.TabRelat[j][2];
		  			if (component.equals(pZ.Zsp.TabRelat[j][2]))
		  		  		otherComp=pZ.Zsp.TabRelat[j][1];
		  			Element rel = new Element("Relation");
		  			Attribute NameR = new Attribute("Name",RelName);
		  			rel.setAttribute(NameR);
		  			comp.addContent(rel);
		  			Element ConnectedComp = new Element("ConnectedComponent");
		  			Attribute NameCC = new Attribute("Name",otherComp);
		  			ConnectedComp.setAttribute(NameCC);
		  			rel.addContent(ConnectedComp);
		  			boolean existD=false,existR=false;
		  			for(int k=0;k<pZ.Zsp.nbDR;k++){		  				
		  				if(pZ.Zsp.TabDomRan[k][0].equals("\\dom")){
		  					if(pZ.Zsp.TabDomRan[k][1].equals(RelName))
		  							existD=true;
		  				}
		  			}
		  			for(int k=0;k<pZ.Zsp.nbDR;k++){
		  				if(pZ.Zsp.TabDomRan[k][0].equals("\\ran")){
		  					if(pZ.Zsp.TabDomRan[k][1].equals(RelName))
		  							existR=true;
		  				}
		  			}
		  			if(existD && existR){
		  					Element DomRan = new Element("DomaineRangeSpecification");
		  					Attribute valueDR = new Attribute("Type","True");
		  					DomRan.setAttribute(valueDR);
		  					rel.addContent(DomRan);	
		  			}
		  			
		  		for(int h=0;h<pZ.nbOp;h++){
		  			boolean existOp=false;
		  			String Number="Correct"; //il faut une seul opeartion par ligne.
		  			String OpName=pZ.TabOpeartion[h];
		  			pZ.Zsp.OperationSchema(OpName);
		  			int u=0;
		  			while((u<pZ.Zsp.nbPost) && !existOp){
		  				if((pZ.Zsp.TabPost[u].indexOf(RelName)>(-1))&&(((pZ.Zsp.TabPost[u].indexOf("\\cup"))>(-1))||((pZ.Zsp.TabPost[u].indexOf("\\setminus"))>(-1)))){
		  					if(((pZ.Zsp.TabPost[u].indexOf("\\cup"))>(-1))&&((pZ.Zsp.TabPost[u].indexOf("\\setminus"))>(-1))){
		  						Number="Incorrect";
		  					}
		  					existOp=true;
		  				}	
		  			u++;	
		  			}
		  			if(existOp){
		  				Element Op = new Element("Opeartion");
	  					Attribute OpN = new Attribute("Name",OpName);
	  					Attribute value = new Attribute("Value",Number);
	  					Op.setAttribute(OpN);
	  					Op.setAttribute(value);
	  					rel.addContent(Op);	
		  			} 			
		  		}
		  	}
	  	}
	 
	
	  String cp=getNameComp(component);		
	  		
	 for(int h=0;h<pZ.nbOp;h++){
  			boolean existOp=false;
  			String Number="Correct"; //il faut une seul opeartion par ligne. 
  			String OpName=pZ.TabOpeartion[h];
  			pZ.Zsp.OperationSchema(OpName);
  			int u=0;
  			while((u<pZ.Zsp.nbPost) && !existOp){
  				if((pZ.Zsp.TabPost[u].indexOf(cp)>(-1))&&(((pZ.Zsp.TabPost[u].indexOf("\\cup"))>(-1))||((pZ.Zsp.TabPost[u].indexOf("\\setminus"))>(-1)))){
  					if(((pZ.Zsp.TabPost[u].indexOf("\\cup"))>(-1))&&((pZ.Zsp.TabPost[u].indexOf("\\setminus"))>(-1))){
  						Number="Incorrect";
  					}
  					existOp=true;
  				}	
  			u++;	
  			}
  			if(existOp){
  				Element Op = new Element("Opeartion");
				Attribute OpN = new Attribute("Name",OpName);
				Attribute value = new Attribute("Value",Number);
				Op.setAttribute(OpN);
				Op.setAttribute(value);
				comp.addContent(Op);	
  			} 			
  		}	 
		 
	}	 
  		 
     XMLOutputter sortie = new XMLOutputter();
     sortie.output(doc, new FileOutputStream(f));
	}
	catch(Exception e){System.out.println("XMLCreation Exception...");}
	}
	
	public static void main(String args[]){
		XMLCreation cr = new XMLCreation("PMSlim.tex");
		cr.createXML();
	}
	
	public String getNameComp(String Comp){
		String c="";
		for(int i=0;i<pZ.Zsp.nbC;i++){
			if(pZ.Zsp.TabComp[i][2].equals(Comp)){
				c=pZ.Zsp.TabComp[i][0];
			}
		}
		return c;
	}
}
