package CompileZ;
/** 
 * Transllate the Z opeartors to JAVA code. 
 * @author  Slim KALLEL
 * @version 1.0 20-11-06
 */
import java.io.*;
import org.w3c.dom.*;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamSource;
import javax.xml.XMLConstants;
import javax.xml.validation.Schema;
import javax.xml.validation.SchemaFactory;
import javax.xml.validation.Validator;
import javax.swing.*;


/**
 *
 * @author Slim
 */
class XMLValidation{
     	String XMLfile, XSDfile;
     	
    
    /** Creates a new instance of XMLValidation */
    XMLValidation(String XMLf, String XSDf){
     		XMLfile =XMLf;
     		XSDfile =XSDf;
     	}
    


public static void main(String args[]){	
			XMLValidation xmlV = new XMLValidation("Zspecification.xml","MetaModel.xsd");
     		xmlV.validate();		
     	}	
     	public void validate(){
		       try {
		            DocumentBuilder parser =DocumentBuilderFactory.newInstance().newDocumentBuilder();
		            Document document = parser.parse(new File(XMLfile));
		            SchemaFactory factory = SchemaFactory.newInstance(XMLConstants.W3C_XML_SCHEMA_NS_URI);
		            Source schemaFile = new StreamSource(new File(XSDfile));
		            Schema schema = factory.newSchema(schemaFile);
		            Validator validator = schema.newValidator();
                            BillyErrorHandler billyErrorHandler = new BillyErrorHandler();
                            validator.setErrorHandler(billyErrorHandler);
		            validator.validate(new DOMSource(document));
                            if (!billyErrorHandler.isValid()){
                                JOptionPane.showMessageDialog(null, "XML is valid", "Information",JOptionPane.INFORMATION_MESSAGE);
                            }
                            }
		        catch (Exception err) {
		            System.out.println("IOException"); 
                            JOptionPane.showMessageDialog(null, "XML File not exist or XML is not well-formed", "Error",JOptionPane.ERROR_MESSAGE);
			}
     	}
     	
     } 

      
      
