package CompileZ;

import javax.swing.*;
import java.awt.*; 
import java.io.File; 
import javax.swing.filechooser.*;
import org.jdesktop.jdic.desktop.Desktop;
import org.jdesktop.jdic.desktop.DesktopException;

import java.awt.Toolkit;


public class Interface extends JFrame {
    
    String ZFile="";
    String XMLFile="";String P3File="";
    boolean isXmlLoad=false;
    String [] alltransition;
    boolean auto=true;
    
    String title= "SFAx : de la Specification Formelle aux Aspects";
    
    String Zeveslink="C:\\Z-EVES\\2.1\\gui\\toplevel.pyc";
    String pythonlink="C:\\Program Files\\Python\\pythonw.exe";
    String p3link="C:\\Program Files\\GoodOldAI\\P3\\P3.exe";
    
    private javax.swing.JLabel affiche;

    
    
    
    public Interface() {
        initComponent();
        getPosition();      
    }
  
    void getPosition(){
        Toolkit k = Toolkit.getDefaultToolkit();
        Dimension tailleEcran = k.getScreenSize();
        int largeurEcran = tailleEcran.width;
        int hauteurEcran = tailleEcran.height;
        setLocation(largeurEcran*3/8, hauteurEcran*3/8);
    }
   
    
    void initComponent() {
    	
    	getContentPane().setLayout(null);
    	
    	jPanel1 = new javax.swing.JPanel();
    	 jPanel1.setLayout(null);
    	 jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("SFAx"));
    	 getContentPane().add(jPanel1);
    	 jPanel1.setBounds(20, 30, 400, 140);
    	 jPanel1.setVisible(false);
    	
    	petri = new javax.swing.JLabel();
    	z = new javax.swing.JLabel();
    	Mapping = new javax.swing.JLabel();
    	aspects = new javax.swing.JLabel();
    	
    	petri.setText("");
    	petri.setBounds(10,20,400,20);
    	jPanel1.add(petri);
        
        z.setText("");
        z.setBounds(10,50,400,20);
        jPanel1.add(z);
        
        Mapping.setText("");
        Mapping.setBounds(10,80,400,20);
        jPanel1.add(Mapping);
        
        aspects.setText("");
        aspects.setBounds(10,110,400,20);
        jPanel1.add(aspects);

    	affiche = new javax.swing.JLabel();
        affiche.setText("");
        affiche.setBounds(10,280,400,20);
        getContentPane().add(affiche);

        this.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("");
            }
        });
    	
        menuBar = new javax.swing.JMenuBar();
        
        fileMenu = new javax.swing.JMenu();
        loadXmlMenuItem = new javax.swing.JMenuItem();
        openMenuItem = new javax.swing.JMenuItem();
        exitMenuItem = new javax.swing.JMenuItem();
          
        jSeparator1 = new javax.swing.JSeparator();
        jSeparator2 = new javax.swing.JSeparator();
        
        MetaModel = new javax.swing.JMenu();
        Checks = new javax.swing.JMenuItem();
        View = new javax.swing.JMenu();
        XMLView = new javax.swing.JMenuItem();
        XSDView = new javax.swing.JMenuItem();
        
        AOP = new javax.swing.JMenu();
        pc = new javax.swing.JMenu();
        MapPointCut = new javax.swing.JMenuItem();
        PointCutView = new javax.swing.JMenuItem();
        PointCutEdit = new javax.swing.JMenuItem();
        Generation = new javax.swing.JMenu();
        Auto = new javax.swing.JMenuItem();
        NoAuto = new javax.swing.JMenuItem();
        
        tools = new javax.swing.JMenu();
        zeves = new javax.swing.JMenuItem();
        p3 = new javax.swing.JMenuItem();
        
        helpMenu = new javax.swing.JMenu();
        contentsMenuItem = new javax.swing.JMenuItem();
        configureMenuItem  = new javax.swing.JMenuItem();
        aboutMenuItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle(title);
        fileMenu.setText("File");
        fileMenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileMenuActionPerformed(evt);
            }
        });
        
        // loadXmlMenuItem
        loadXmlMenuItem.setText("Load Petri Net");
        loadXmlMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadXMLMenuItemActionPerformed(evt);
            }
        });
        loadXmlMenuItem.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("Load the XML file generated from the tool P3");
            }
        });
        fileMenu.add(loadXmlMenuItem);
        
        
        
        openMenuItem.setText("Load Z Specification");
        openMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openMenuItemActionPerformed(evt);
            }
        });
        openMenuItem.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("Load the Tex file generated from the tool Z/EVES");
            }
        });
        fileMenu.add(openMenuItem);
        
        fileMenu.add(jSeparator1);
        
        
        exitMenuItem.setText("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });
        exitMenuItem.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("");
            }
        });

        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        
        MetaModel.setText("Z MetaModel");
        Checks.setText("Ckeck");
        Checks.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ChecksActionPerformed(evt);
            }
        });
        Checks.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("Check that the Z specification is compliant with the MetaModel");
                
            }
        });
        MetaModel.add(Checks);

        View.setText("View");
        XMLView.setText("Z2XML file");
        XMLView.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                XMLViewActionPerformed(evt);
            }
        });
        XMLView.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("View The XML file generated from Z Specification");
                
            }
        });
        View.add(XMLView);

        XSDView.setText(" XSD file");
        XSDView.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                XSDViewActionPerformed(evt);
            }
        });
        XSDView.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("View the XML schema MetaModel");
                
            }
        });
        View.add(XSDView);
        MetaModel.add(View);
        menuBar.add(MetaModel);

        
        AOP.setText("Aspects");
        AOP.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("");
                
            }
        });
        MapPointCut.setText("Create");
        MapPointCut.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	MapPointCutActionPerformed(evt);
            }
        });
        MapPointCut.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("Create the skeleton of the XML mapping file");
                
            }
        });
        
        PointCutView.setText("View");
        PointCutView.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	PointCutViewActionPerformed(evt);
            }
        });
        PointCutView.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("View the XML mapping file");
                
            }
        });
        
        PointCutEdit.setText("Edit");
        PointCutEdit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	PointCutEditActionPerformed(evt);
            }
        });
        PointCutEdit.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("Edit the XML mapping file");
                
            }
        });
        pc.setText("Pointcut Mapping");

        pc.add(MapPointCut);
        pc.add(PointCutView);
        pc.add(PointCutEdit);
        
        AOP.add(pc);

        Auto.setText("Automatic");
        NoAuto.setText("Semi-Automatic");
        
        
        
        
        Generation.setText("Generate");
        
        
        Auto.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                GenerationActionPerformed(evt);
                auto=true;
            }
        });
        Auto.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("Generate automatically the aspectJ aspects");
                
            }
        });
        
        NoAuto.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	auto=false;
            	GenerationActionPerformed(evt);
                
            }
        });
        NoAuto.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("Generate semi-automatically the aspectJ aspects");
                
            }
        });
        
        Generation.add(Auto);
        Generation.add(NoAuto);
        
        AOP.add(Generation);

        tools.setText("Tools");
        zeves.setText("Z-EVES");
        zeves.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                zevesActionPerformed(evt);
            }
        });
        zeves.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("Start the tool Z/EVES");
                
            }
        });
        
        p3.setText("P3");
        p3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                p3ActionPerformed(evt);
            }
        });
        p3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("Start the tool P3");
                
            }
        });
        
        tools.add(zeves);
        tools.add(p3);
        
        
        menuBar.add(AOP);
        menuBar.add(tools);
        helpMenu.setText("Help");
        
        configureMenuItem.setText("Configuration");
        helpMenu.add(configureMenuItem);
        
        
        configureMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ConfigActionPerformed(evt);
            }
        });
        configureMenuItem.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("Configure the tools path Z/EVES and P3");
                
            }
        });
        helpMenu.add(jSeparator2);
        contentsMenuItem.setText("Contents");
        helpMenu.add(contentsMenuItem);
        
        contentsMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	contentsActionPerformed(evt);
            }
        });
        contentsMenuItem.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("");
            }
        });

        aboutMenuItem.setText("About");
        aboutMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	new About();
            }
        });
        
        aboutMenuItem.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                affiche.setText("");
            }
        });
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        setJMenuBar(menuBar);
        setSize(500,350);

    }
    
    
    void contentsActionPerformed(java.awt.event.ActionEvent evt) { 	
    	try {
            Desktop.open(new File("Coordination07.pdf"));
        	} catch (DesktopException e) {
            e.printStackTrace();
        }	
    }
    
    void ConfigActionPerformed(java.awt.event.ActionEvent evt) {
    	new Configuration(this);	
    }
    
    void zevesActionPerformed(java.awt.event.ActionEvent evt) {
    	Runtime run = Runtime.getRuntime();
        try {
           run.exec(pythonlink+" "+Zeveslink);
           
        } catch (Exception e) {
            e.printStackTrace();
            System.out.println(e.getMessage());
         }
    }
    
    void p3ActionPerformed(java.awt.event.ActionEvent evt) {
    	Runtime run = Runtime.getRuntime();
        try {
        	System.out.println("P3File "+P3File);
           run.exec(p3link+" \""+ P3File+"\"");
           
        } catch (Exception e) {
            e.printStackTrace();
            System.out.println(e.getMessage());
         }
    }
    
   
    
    void GenerationActionPerformed(java.awt.event.ActionEvent evt) {
    		
    	 String path="Aspects";
    	 JFileChooser choix = new JFileChooser(".");
         choix.setApproveButtonText("Ok");
         choix.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

         if(choix.showOpenDialog(null)== JFileChooser.APPROVE_OPTION){
            path = choix.getSelectedFile().getAbsolutePath();
         //System.out.println(">>"+path);
         }
         
        if(isXmlLoad) {
	        TransformPetriNets tpn = new TransformPetriNets(XMLFile,path);
	 		tpn.readXML();
	 		
	 		alltransition=tpn.AllTransisition;
        } 
         
    	ParsingZ pz = new ParsingZ(ZFile);
    	String styleSchema=pz.getStyleSchemaName();
    	
    	
    	AspectGeneration ag = new AspectGeneration(ZFile,styleSchema,path,isXmlLoad,alltransition,auto);
    	pz.getOperationName(styleSchema);
    	ag.GenerateSystemState();
    	
    	
    	
		for(int i=0;i<pz.nbOp;i++){
			ag.createAspect(pz.TabOpeartion[i]);
			aspects.setText("* "+pz.nbOp+" aspects are generated in the selected directory" );

		}
    }

    void XSDViewActionPerformed(java.awt.event.ActionEvent evt) {
        try {
            Desktop.open(new File("MetaModel.xsd"));
        	} catch (DesktopException e) {
            e.printStackTrace();
        }
    }

    void XMLViewActionPerformed(java.awt.event.ActionEvent evt) {
        try {
            Desktop.open(new File("Zspecification.xml"));
        	} catch (DesktopException e) {
            e.printStackTrace();
        }
    }

    void ChecksActionPerformed(java.awt.event.ActionEvent evt) {
        XMLValidation xmlV = new XMLValidation("Zspecification.xml","MetaModel.xsd");
     	xmlV.validate();
    }

    void fileMenuActionPerformed(java.awt.event.ActionEvent evt) {
    }
    
    void MapPointCutActionPerformed(java.awt.event.ActionEvent evt) {

    	PointCutCreation PCc = new PointCutCreation(ZFile);
    	PCc.createPc();
    	Mapping.setText("* The skeleton of mapping file is generated ");

    }
    
    void PointCutEditActionPerformed(java.awt.event.ActionEvent evt) {
    	try {
            Desktop.edit(new File("Mapping/Mapping.xml"));
        	} catch (DesktopException e) {
            e.printStackTrace();
        }
    }
    
    void PointCutViewActionPerformed(java.awt.event.ActionEvent evt) {
    	try {
            Desktop.open(new File("Mapping//Mapping.xml"));
        	} catch (DesktopException e) {
            e.printStackTrace();
            System.out.println("Mapping view Exception");
        }
    }
    
    void openMenuItemActionPerformed(java.awt.event.ActionEvent evt) {
    	
    	// lecture du fichier LATEX
        FileFilter tex = new FiltreSimple("Tex File",".tex");		
		JFileChooser chooser = new JFileChooser(".");
		chooser.addChoosableFileFilter(tex);
            if (chooser.showOpenDialog(null) == JFileChooser.APPROVE_OPTION){
                 ZFile=chooser.getSelectedFile().getAbsolutePath();
                 jPanel1.setVisible(true);
                 z.setText("* The Z specification " +chooser.getSelectedFile().getName()+" is loaded");

            }
       XMLCreation cr = new XMLCreation(ZFile);
       cr.createXML();
            
    }
    
    void loadXMLMenuItemActionPerformed(java.awt.event.ActionEvent evt) {
    	
    	// lecture du fichier XML
        FileFilter tex = new FiltreSimple("XML File",".xml");		
		JFileChooser chooser = new JFileChooser(".");
		chooser.addChoosableFileFilter(tex);
            if (chooser.showOpenDialog(null) == JFileChooser.APPROVE_OPTION){
                 XMLFile=chooser.getSelectedFile().getAbsolutePath();
                 jPanel1.setVisible(true);
                 petri.setText("* The Petri net " +chooser.getSelectedFile().getName()+" is loaded");
            }        
       isXmlLoad=true; 
       String fileWithoutExt= XMLFile.substring(0,XMLFile.length()-3);
       P3File= fileWithoutExt+""+"p3";
    }
    
    void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {
        System.exit(0);
    }
    
    public static void main(String args[]) { 	
    	Interface I = new Interface();
    	I.setVisible(true);
    }
     
    javax.swing.JLabel petri;
    javax.swing.JLabel z;
    javax.swing.JLabel Mapping;
    javax.swing.JLabel aspects;
    
    JPanel jPanel1;
    javax.swing.JMenu AOP;
    javax.swing.JMenu tools;
    javax.swing.JMenuItem Checks;
    javax.swing.JMenuItem zeves;
    javax.swing.JMenuItem p3;
    javax.swing.JMenu Generation;
    javax.swing.JMenuItem Auto;
    javax.swing.JMenuItem NoAuto;
    javax.swing.JMenu MetaModel;
    javax.swing.JMenuItem MapPointCut;
    javax.swing.JMenuItem PointCutView;
    javax.swing.JMenuItem PointCutEdit;
    javax.swing.JMenu View;
    javax.swing.JMenu pc;
    javax.swing.JMenuItem XMLView;
    javax.swing.JMenuItem XSDView;
    javax.swing.JMenuItem aboutMenuItem;
    javax.swing.JMenuItem contentsMenuItem;
    javax.swing.JMenuItem configureMenuItem;
    javax.swing.JMenuItem exitMenuItem;
    javax.swing.JMenu fileMenu;
    javax.swing.JMenu helpMenu;
    javax.swing.JMenuBar menuBar;
    javax.swing.JMenuItem openMenuItem;
    javax.swing.JMenuItem loadXmlMenuItem;  
    javax.swing.JSeparator jSeparator1;
    javax.swing.JSeparator jSeparator2;
    
}

class FiltreSimple extends FileFilter{
	private String description;
	private String extension;
	public FiltreSimple(String description, String extension){
		if(description == null || extension ==null){
			throw new NullPointerException("La description (ou extension) ne peut tre null.");	
		}
		this.description = description;
		this.extension = extension;
	}
	public boolean accept(File file){
		if(file.isDirectory()) { 
			return true; 
		} 
		String nomFichier = file.getName().toLowerCase(); 
		return nomFichier.endsWith(extension);
	}		
	public String getDescription(){
		return description;
	}
}






/*class Affiche extends JPanel
{
  Image fond, monde;

  Affiche(String s)
    {
      fond = getToolkit().getImage(s);
      
      setPreferredSize(new Dimension(300, 200));
    }

  public void paintComponent(Graphics g)
  {
    super.paintComponent(g);
    g.drawImage(fond,0,0, this);
  }
} 
*/

